// Meyers Item 2, p.12

class Widget { };
class SpecialWidget : public Widget { };

void update( SpecialWidget *psw );
void updateViaRef( SpecialWidget *rsw );
void update( SpecialWidget *psw ) { }
void updateViaRef( SpecialWidget& rsw ) { }

typedef void (*FuncPtr)( );
int doSomething( ) { return 0; }

int main ( )
 {
  int firstNumber = 10;
  int secondNumber = 3;
  double result = static_cast<double>( firstNumber ) / secondNumber;

  SpecialWidget sw;
  const SpecialWidget& csw = sw;
  update( const_cast<SpecialWidget*>( &csw ) );

  FuncPtr funcPtrArray[10];
  funcPtrArray[0] = reinterpret_cast<FuncPtr>( &doSomething );
   
  return 0;
 }
