#include <iostream>

#include <cppconfig>

int main ( )
 {
  cout << "standard casts:                  ";
  #ifdef cpp_missing_std_casts
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard exceptions:             ";
  #ifdef cpp_missing_std_exceptions
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard rtti:                   ";
  #ifdef cpp_missing_std_rtti
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << endl;

  cout << "type bool:                       ";
  #ifdef cpp_missing_type_bool
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "type wchar_t:                    ";
  #ifdef cpp_missing_type_wchar_t
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << endl;

  cout << "keyword explicit:                ";
  #ifdef cpp_missing_keyword_explicit
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "keyword mutable:                 ";
  #ifdef cpp_missing_keyword_mutable
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "keyword namespace:               ";
  #ifdef cpp_missing_keyword_namespace
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "keyword typename:                ";
  #ifdef cpp_missing_keyword_typename
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << endl;

  cout << "operator keywords:               ";
  #ifdef cpp_missing_keyword_operators
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << endl;

  cout << "template defaults:               ";
  #ifdef cpp_missing_template_defaults
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "template methods:                ";
  #ifdef cpp_missing_template_methods
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "template partial specialization: ";
  #ifdef cpp_missing_template_partial
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "template template parameters:    ";
  #ifdef cpp_missing_template_ttp
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << endl;

  cout << "standard headers:                ";
  #ifdef cpp_missing_std_headers
    cout << "NOT ALL SUPPORTED";
  #else
    cout << "all supported";
  #endif
  cout << endl;

  cout << endl;

  cout << "standard header algorithm:       ";
  #ifdef cpp_missing_header_algorithm
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header bitset:          ";
  #ifdef cpp_missing_header_bitset
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header complex:         ";
  #ifdef cpp_missing_header_complex
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header deque:           ";
  #ifdef cpp_missing_header_deque
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header exception:       ";
  #ifdef cpp_missing_header_exception
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header fstream:         ";
  #ifdef cpp_missing_header_fstream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header functional:      ";
  #ifdef cpp_missing_header_functional
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header iomanip:         ";
  #ifdef cpp_missing_header_iomanip
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header ios:             ";
  #ifdef cpp_missing_header_ios
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header iosfwd:          ";
  #ifdef cpp_missing_header_iosfwd
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header iostream:        ";
  #ifdef cpp_missing_header_iostream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header istream:         ";
  #ifdef cpp_missing_header_istream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header iterator:        ";
  #ifdef cpp_missing_header_iterator
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header limits:          ";
  #ifdef cpp_missing_header_limits
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header list:            ";
  #ifdef cpp_missing_header_list
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header locale:          ";
  #ifdef cpp_missing_header_locale
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header map:             ";
  #ifdef cpp_missing_header_map
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header memory:          ";
  #ifdef cpp_missing_header_memory
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header new:             ";
  #ifdef cpp_missing_header_new
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header numeric:         ";
  #ifdef cpp_missing_header_numeric
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header ostream:         ";
  #ifdef cpp_missing_header_ostream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header queue:           ";
  #ifdef cpp_missing_header_queue
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header sstream:         ";
  #ifdef cpp_missing_header_sstream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header stack:           ";
  #ifdef cpp_missing_header_stack
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header stdexcept:       ";
  #ifdef cpp_missing_header_stdexcept
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header streambuf:       ";
  #ifdef cpp_missing_header_streambuf
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header string:          ";
  #ifdef cpp_missing_header_string
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header set:             ";
  #ifdef cpp_missing_header_set
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header typeinfo:        ";
  #ifdef cpp_missing_header_typeinfo
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header utility:         ";
  #ifdef cpp_missing_header_utility
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header valarray:        ";
  #ifdef cpp_missing_header_valarray
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header vector:          ";
  #ifdef cpp_missing_header_vector
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cassert:         ";
  #ifdef cpp_missing_header_cassert
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cctype:          ";
  #ifdef cpp_missing_header_cctype
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cerrno:          ";
  #ifdef cpp_missing_header_cerrno
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cfloat:          ";
  #ifdef cpp_missing_header_cfloat
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header ciso646:         ";
  #ifdef cpp_missing_header_ciso646
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header climits:         ";
  #ifdef cpp_missing_header_climits
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header clocale:         ";
  #ifdef cpp_missing_header_clocale
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cmath:           ";
  #ifdef cpp_missing_header_cmath
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header csetjmp:         ";
  #ifdef cpp_missing_header_csetjmp
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header csignal:         ";
  #ifdef cpp_missing_header_csignal
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cstdarg:         ";
  #ifdef cpp_missing_header_cstdarg
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cstddef:         ";
  #ifdef cpp_missing_header_cstddef
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cstdio:          ";
  #ifdef cpp_missing_header_cstdio
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cstdlib:         ";
  #ifdef cpp_missing_header_cstdlib
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cstring:         ";
  #ifdef cpp_missing_header_cstring
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header ctime:           ";
  #ifdef cpp_missing_header_ctime
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cwchar:          ";
  #ifdef cpp_missing_header_cwchar
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard header cwctype:         ";
  #ifdef cpp_missing_header_cwctype
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << endl;

  cout << "standard classes:                ";
  #ifdef cpp_missing_std_classes
    cout << "NOT ALL SUPPORTED";
  #else
    cout << "all supported";
  #endif
  cout << endl;

  cout << endl;

  cout << "standard class bitset:           ";
  #ifdef cpp_missing_class_bitset
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class complex:          ";
  #ifdef cpp_missing_class_complex
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class deque:            ";
  #ifdef cpp_missing_class_deque
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class fstream:          ";
  #ifdef cpp_missing_class_fstream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class ios_base:         ";
  #ifdef cpp_missing_class_ios_base
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class istream:          ";
  #ifdef cpp_missing_class_istream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class iterator:         ";
  #ifdef cpp_missing_class_iterator
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class list:             ";
  #ifdef cpp_missing_class_list
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class map:              ";
  #ifdef cpp_missing_class_map
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class multimap:         ";
  #ifdef cpp_missing_class_multimap
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class multiset:         ";
  #ifdef cpp_missing_class_multiset
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class ostream:          ";
  #ifdef cpp_missing_class_ostream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class priority_queue:   ";
  #ifdef cpp_missing_class_priority_queue
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class queue:            ";
  #ifdef cpp_missing_class_queue
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class set:              ";
  #ifdef cpp_missing_class_set
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class stringstream:     ";
  #ifdef cpp_missing_class_stringstream
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class stack:            ";
  #ifdef cpp_missing_class_stack
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class streambuf:        ";
  #ifdef cpp_missing_class_streambuf
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class string:           ";
  #ifdef cpp_missing_class_string
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class valarray:         ";
  #ifdef cpp_missing_class_valarray
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  cout << "standard class vector:           ";
  #ifdef cpp_missing_class_vector
    cout << "NOT SUPPORTED";
  #else
    cout << "supported";
  #endif
  cout << endl;

  return 0;
 }
