// Stroustrup 13.5, page 341

template<class T>
class Vector
 {
  public:
   Vector( );
   Vector( int );
  
   T& elem( int i ) { return v[i]; }
   T& operator[]( int i );

  private:
   T* v;
   int sz;
 };

template<>
class Vector<void*>
 {
  public:
   void*& operator[]( int i );

  private:
   void** p;
 };

template<class T>
class Vector<T*> : private Vector<void*>
 {
  public:
   typedef Vector<void*> Base;

   Vector( ) : Base( ) { }
   explicit Vector( int i ) : Base( i ) { }

   T*& elem( int i ) { return static_cast<T*&>( Base::elem( i ) ); }
   T*& operator[]( int i ) { return static_cast<T*&>( Base::operator[]( i ) ); }
 };

int main( )
 {
   Vector<void*> vpv;
   Vector<int**> vppi;

   return 0;
 }
