/* --------------------------------------------------------------------------
 *
 * namespace FortranTypes
 *   typedefs consistent with fortran types
 *
 * required headers
 *   see include header file FortranTypes
 *
 * --------------------------------------------------------------------------
 * $Id$
 * ---------------------------------------------------------------------------- */

#ifndef __FortranTypes_H__
#define __FortranTypes_H__

cpp_gnamespace_begin( FortranTypes )

  // --------------------------- typedefs consistent with standard fortran types
  // ---------------------------------------------------------------------------

  typedef char     character;
  typedef int      integer;
  typedef long int logical;
  typedef float    sReal;
  typedef double   dReal;

  // ATTN typedefs compatible with the fortran complex types have not been
  // ATTN added for want of a c++ representation capable of handling  both
  // ATTN single complex numbers as well as arrays of complex numbers that
  // ATTN is compatible with the corresponding fortran representations.

cpp_gnamespace_end

#endif /* __FortranTypes_H__ */
