/* --------------------------------------------------------------------------
 *
 * cppbvls
 *   C++ prototype for bvls.f
 *
 * required headers
 *   see include header file cppbvls
 *
 * notes
 *   function arguments have been changed into const/non-const references
 *
 * --------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------- */

#ifndef __cppbvls_H__
#define __cppbvls_H__

cpp_using_namespace( FortranTypes );

extern "C"
 {
  // void
  // bvls( const integer& key, const integer& m, const integer& n,
  //       const dReal& a, const dReal& b, const dReal& bl, const dReal& bu,
  //       dReal& x, dReal& w, dReal& act, dReal& zz, integer& istate, integer& loopA );
  void
  bvls( integer* key, integer* m, integer* n,
        dReal* a, dReal* b, dReal* bl, dReal* bu,
        dReal* x, dReal* w, dReal* act, dReal* zz, integer* istate, integer* loopA );
 } /* extern "C" {} */

#endif /* __cppbvls_H__ */
