#!/bin/tcsh -f

# ---------------------------------------------------------------------------
#
# script usable by brain1.0b style makefiles
#  run a sequence of commands specified on the command line.
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

 if ( "$*" == "-help" ) then
  echo '${0:t} "command 1" "command 2" ...'
  exit 0
 endif

 limit coredumpsize 0

 set i = 1
 while ( ${i} <= ${#argv} )
  echo "\n>> ${argv[${i}]}\n"
  eval "${argv[${i}]}"
  if ( ${status} ) exit ${status}
  set s = ${status}
  echo "\n>> previous command status: ${s}\n"
  if ( ${s} ) exit ${s}
  @ i += 1
 end
